@echo off

::wpeutil ListKeyboardLayouts 0x0409
::wpeutil SetKeyboardLayout 0409:00000409

:: see - http://windowsitpro.com/systems-management/how-do-i-configure-default-keyboard-layout-during-login
:: and - http://msdn.microsoft.com/en-us/goglobal/bb895996
:: and - http://www.science.co.il/Language/Locale-codes.asp

REG QUERY "HKU\.DEFAULT\Control Panel\International" /v Locale > "%temp%\random.test.txt"
FOR /F "tokens=3" %%i IN ('FINDSTR /C:Locale "%temp%\random.test.txt"') DO SET CURRENT.REGION=%%i
set CURRENT.REGION=%CURRENT.REGION:~-4%

:_menu
cls
echo.
echo Set Keyboard Layout
echo ===================
echo.
echo Enter a keyboard layout in the format
echo en-us (case sensitive) or select one 
echo of the following options -
echo.
echo   1] View supported layouts
echo   2] Exit
echo.
set /p LANG="Enter your choice: "
IF "%LANG%"=="1" GOTO _options
IF "%LANG%"=="2" GOTO _exit
IF "%LANG%"=="bg" SET DATA=%CURRENT.REGION%:00000402 & GOTO _run
IF "%LANG%"=="hr" SET DATA=%CURRENT.REGION%:0000041a & GOTO _run
IF "%LANG%"=="cs" SET DATA=%CURRENT.REGION%:00000405 & GOTO _run
IF "%LANG%"=="da" SET DATA=%CURRENT.REGION%:00000406 & GOTO _run
IF "%LANG%"=="nl-nl" SET DATA=%CURRENT.REGION%:00000413 & GOTO _run
IF "%LANG%"=="nl-be" SET DATA=%CURRENT.REGION%:00000813 & GOTO _run
IF "%LANG%"=="en-us" SET DATA=%CURRENT.REGION%:00000409 & GOTO _run
IF "%LANG%"=="en-gb" SET DATA=%CURRENT.REGION%:00000809 & GOTO _run
IF "%LANG%"=="en-ca" SET DATA=%CURRENT.REGION%:00001009 & GOTO _run
IF "%LANG%"=="en-nz" SET DATA=%CURRENT.REGION%:00001409 & GOTO _run
IF "%LANG%"=="en-au" SET DATA=%CURRENT.REGION%:00000c09 & GOTO _run
IF "%LANG%"=="fi" SET DATA=%CURRENT.REGION%:0000040b & GOTO _run
IF "%LANG%"=="fr-fr" SET DATA=%CURRENT.REGION%:0000040c & GOTO _run
IF "%LANG%"=="de-de" SET DATA=%CURRENT.REGION%:00000407 & GOTO _run
IF "%LANG%"=="it-it" SET DATA=%CURRENT.REGION%:00000410 & GOTO _run
IF "%LANG%"=="pt-pt" SET DATA=%CURRENT.REGION%:00000816 & GOTO _run
IF "%LANG%"=="es-mx" SET DATA=%CURRENT.REGION%:0000080a & GOTO _run
IF "%LANG%"=="es-es" SET DATA=%CURRENT.REGION%:0000040a & GOTO _run
cls
echo.
echo This option (%LANG%) is not supported. 
echo Remember that options are case sensitive.
echo. 
PAUSE
GOTO _menu


:_options
cls
echo.
notepad.exe %~dp0KeyboardLayouts.txt
echo.
echo.
echo.
GOTO _menu


:_run
cls
echo.
ECHO wpeutil SetKeyboardLayout %DATA%
wpeutil SetKeyboardLayout %DATA%
echo.
echo.
echo.
PAUSE



:_exit
cls
EXIT

